
package com.loafle;
import static org.junit.Assert.*;

import com.loafle.overflow.crawler.Crawler;
import com.loafle.overflow.crawler.config.*;
import com.loafle.overflow.crawler.jmx.JmxCrawler;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

public class AppTest {
    @Test
    public void testSum() {
        assertEquals(1,1);
    }

    @Test
    public void TestDoCrawler() throws Exception {
//        JmxCrawler jmxCrawler = new JmxCrawler(
////                "service:jmx:rmi:///jndi/rmi://192.168.1.207:7199/jmxrmi",
//                "service:jmx:rmi:///jndi/rmi://192.168.1.103:9840/jmxrmi",
////                "",
//                "",
//                "",
//                false,
//                new JmxCrawler.StdoutWriter()
//        );
//
//        jmxCrawler.doCrawler();

        Config config = new Config();

        config.setId("SOEJWEOJWOEJOSDJFOASDJFOSDFO2903870928734");
        Connection cn = new Connection();
        cn.setIp("192.168.1.103");
        cn.setPort("9840");
        cn.setSsl(false);
        cn.setPortType("tcp");

        Target t = new Target();
        t.setConnection(cn);

        Schedule s = new Schedule();
        s.setInterval("10");

        com.loafle.overflow.crawler.config.Crawler cc = new com.loafle.overflow.crawler.config.Crawler();
        cc.setName("jmx_crawler");
        cc.setContainer("java_crawler");

        List<Item> ls = new ArrayList<>();
        List<String> metrics = new ArrayList<>();
        List<Query> queries = new ArrayList<>();
        List<String> keys = new ArrayList<>();
        keys.add("ProcessCpuLoad");
        keys.add("ProcessCpuTime");
        keys.add("SystemCpuLoad");

        Query query = new Query();
        query.setKeys(keys);
        query.setQuery("java.lang:type=OperatingSystem");

        queries.add(query);

        metrics.add("cpu.system");
        metrics.add("cpu.user");
        metrics.add("cpu.system_children");
        metrics.add("cpu.user_children");

        Item it = new Item();
        it.setMetrics(metrics);
        it.setQueries(queries);

        ls.add(it);

        config.setTarget(t);
        config.setSchedule(s);
        config.setCrawler(cc);
        config.setItems(ls);

        JmxCrawler cr = new JmxCrawler();

       Object o =  cr.getInternal(config);

        System.out.println("o = " + o);
    }
}